// Copyright (c) 1997-2000  
// Utrecht University (The Netherlands),
// ETH Zurich (Switzerland),
// INRIA Sophia-Antipolis (France),
// Max-Planck-Institute Saarbruecken (Germany),
// and Tel-Aviv University (Israel).  All rights reserved. 
//
// This file is part of CGAL (www.cgal.org); you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 3 of the License,
// or (at your option) any later version.
//
// Licensees holding a valid commercial license may use this file in
// accordance with the commercial license agreement provided with the software.
//
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
// $URL: svn+ssh://scm.gforge.inria.fr/svn/cgal/branches/releases/CGAL-4.0-branch/Kernel_d/include/CGAL/Kernel_d/Interface_classes.h $
// $Id: Interface_classes.h 67093 2012-01-13 11:22:39Z lrineau $
// 
//
// Author(s)     : Michael Seel <seel@mpi-sb.mpg.de>

#ifndef CGAL_INTERFACE_CLASSES_H
#define CGAL_INTERFACE_CLASSES_H

namespace CGAL {

template <class R> class Point_d;
template <class R> class Vector_d;
template <class R> class Direction_d;
template <class R> class Hyperplane_d;
template <class R> class Sphere_d;
template <class R> class Iso_box_d;
template <class R> class Segment_d;
template <class R> class Ray_d;
template <class R> class Line_d;
template <class R> class Aff_transformation_d;

} //namespace CGAL

#endif //CGAL_INTERFACE_CLASSES_H
